Your search did not match any results.

JavaScript/jQuery Charts - Load Data On Demand

In this demo, the range area Chart loads data as you pan it. Once the component loads a data block, this data stays in memory to reduce requests to the server.

www.kaggle.com
Backend API
$(() => { const HALFDAY = 43200000; let packetsLock = 0; $('#chart').dxChart({ dataSource: new DevExpress.data.DataSource({ store: [], sort: 'date', paginate: false, }), title: 'Temperature in Toronto (2025)', zoomAndPan: { argumentAxis: 'pan', }, scrollBar: { visible: true, }, argumentAxis: { argumentType: 'datetime', wholeRange: [new Date(2025, 0, 1), new Date(2025, 11, 31)], visualRange: { startValue: new Date(2025, 3, 1), length: { weeks: 2, }, }, visualRangeUpdateMode: 'keep', }, valueAxis: { name: 'temperature', allowDecimals: false, title: { text: 'Temperature, °C', font: { color: '#ff950c', }, }, label: { font: { color: '#ff950c', }, }, }, series: [{ color: '#ff950c', type: 'rangeArea', argumentField: 'date', rangeValue1Field: 'minTemp', rangeValue2Field: 'maxTemp', name: 'Temperature range', }], onOptionChanged(e) { if (e.fullName === 'argumentAxis.visualRange') { onVisualRangeChanged(e.value, e.component); } }, animation: { enabled: false, }, loadingIndicator: { backgroundColor: 'none', font: { size: 14, }, }, legend: { visible: false, }, }); function onVisualRangeChanged(visualRange, component) { const items = component.getDataSource().items(); if (!items.length || items[0].date - visualRange.startValue >= HALFDAY || visualRange.endValue - items[items.length - 1].date >= HALFDAY) { uploadDataByVisualRange(visualRange, component); } } function uploadDataByVisualRange(visualRange, component) { const dataSource = component.getDataSource(); const ajaxArgs = { startVisible: getDateString(visualRange.startValue), endVisible: getDateString(visualRange.endValue), }; if (!packetsLock) { packetsLock += 1; component.showLoadingIndicator(); getDataFrame(ajaxArgs) .then((dataFrame) => { packetsLock -= 1; const componentStorage = dataSource.store(); dataFrame.forEach((item) => { componentStorage.insert(item); }); dataSource.reload(); const range = component.getArgumentAxis().visualRange(); onVisualRangeChanged(range, component); }, () => { packetsLock -= 1; dataSource.reload(); }); } } function getDataFrame(args) { const deferred = $.Deferred(); $.ajax({ url: 'https://js.devexpress.com/Demos/NetCore/api/TemperatureData', dataType: 'json', data: args, success(result) { deferred.resolve(result.map((i) => ({ date: new Date(i.Date), minTemp: i.MinTemp, maxTemp: i.MaxTemp, }))); }, error() { deferred.reject('Data Loading Error'); }, timeout: 2000, }); return deferred.promise(); } function getDateString(dateTime) { return dateTime ? dateTime.toLocaleDateString('en-US') : ''; } });
<!DOCTYPE html> <html xmlns="http://www.w3.org/1999/xhtml" lang="en"> <head> <title>DevExtreme Demo</title> <meta http-equiv="X-UA-Compatible" content="IE=edge" /> <meta http-equiv="Content-Type" content="text/html; charset=utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" /> <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script> <script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script> <link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.2.8/css/dx.light.css" /> <script src="js/dx.all.js?v=25.2.8"></script> <link rel="stylesheet" type="text/css" href="styles.css" /> <script src="index.js"></script> </head> <body class="dx-viewport"> <div class="demo-container"> <div id="chart"></div> </div> </body> </html>
#chart { height: 440px; }

To implement this functionality, do the following:

  1. Configure a data source.

  2. Configure the Chart to support on-demand data loading.

  3. Implement functions that load the data.

    • In this demo, Chart displays daily information. If a user pan the Chart left or right more than half a day, additional data starts to load. The onVisualRangeChanged initiates this procedure.

    • The uploadDataByVisualRange function analyzes the starting and ending points of the visual range and the bounds of already loaded data. If necessary, it calls the getDataFrame function to obtain new data points. Finally, it reloads the DataSource and saves the current visual range.

    • The getDataFrame Ajax request gets the new data frame from the server.

<template>
<DxChart
id="chart"
ref="chart"
:data-source="chartDataSource"
title="Temperature in Toronto (2025)"
>
<DxZoomAndPan argument-axis="pan"/>
<DxScrollBar :visible="true"/>
<DxArgumentAxis
v-model:visual-range="currentVisualRange"
:whole-range="bounds"
argument-type="datetime"
visual-range-update-mode="keep"
/>
<DxValueAxis
:allow-decimals="false"
name="temperature"
>
<DxTitle text="Temperature, °C">
<DxFont color="#ff950c"/>
</DxTitle>
<DxLabel>
<DxFont color="#ff950c"/>
</DxLabel>
</DxValueAxis>
<DxSeries
color="#ff950c"
type="rangearea"
argument-field="date"
range-value1-field="minTemp"
range-value2-field="maxTemp"
name="Temperature range"
/>
<DxAnimation :enabled="false"/>
<DxLoadingIndicator background-color="none">
<DxFont :size="14"/>
</DxLoadingIndicator>
<DxLegend :visible="false"/>
</DxChart>
</template>
<script setup lang="ts">
import { computed, ref } from 'vue';
import DxChart, {
DxZoomAndPan,
DxScrollBar,
DxArgumentAxis,
DxSeries,
DxValueAxis,
DxTitle,
DxLabel,
DxFont,
DxAnimation,
DxLoadingIndicator,
DxLegend,
} from 'devextreme-vue/chart';
import { DataSource } from 'devextreme-vue/common/data';
import 'whatwg-fetch';
type AjaxArgs = {
startVisible: string;
endVisible: string;
startBound?: string;
endBound?: string;
};
const HALFDAY = 43200000;
const chart = ref();
const visualRange = ref({
startValue: new Date(2025, 3, 1),
endValue: new Date(2025, 3, 15),
});
const chartDataSource = ref(new DataSource({
store: [],
sort: 'date',
paginate: false,
}));
const bounds = ref({
startValue: new Date(2025, 0, 1),
endValue: new Date(2025, 11, 31),
});
let packetsLock = 0;
const currentVisualRange = computed({
get() {
return visualRange.value;
},
set(newRange: { startValue: Date; endValue: Date }) {
const stateStart = visualRange.value.startValue;
const currentStart = newRange.startValue;
if (stateStart.valueOf() !== currentStart.valueOf()) {
visualRange.value = newRange;
}
onVisualRangeChanged();
},
});
function onVisualRangeChanged(): void {
const component = chart.value.instance;
const items: { date: Date }[] = component.getDataSource().items();
if (
!items.length
|| items[0].date?.getTime?.() - visualRange.value.startValue.getTime() >= HALFDAY
|| visualRange.value.endValue.getTime() - items[items.length - 1].date?.getTime?.() >= HALFDAY
) {
uploadDataByVisualRange(visualRange.value, component);
}
}
function uploadDataByVisualRange(
{ startValue, endValue }: { startValue: Date; endValue: Date },
component: any,
): void {
const dataSource = component.getDataSource();
const ajaxArgs: AjaxArgs = {
startVisible: getDateString(startValue),
endVisible: getDateString(endValue),
};
if (!packetsLock) {
packetsLock += 1;
component.showLoadingIndicator();
getDataFrame(ajaxArgs)
.then((dataFrame) => {
packetsLock -= 1;
const componentStorage = dataSource.store();
dataFrame
.map((i: Record<string, any>) => ({
date: new Date(i.Date),
minTemp: i.MinTemp,
maxTemp: i.MaxTemp,
}))
.forEach((item: Record<string, any>) => componentStorage.insert(item));
dataSource.reload();
onVisualRangeChanged();
})
.catch(() => {
packetsLock -= 1;
dataSource.reload();
});
}
}
function getDataFrame(args: AjaxArgs): Promise<any[]> {
let params = '?';
params += `startVisible=${args.startVisible}
&endVisible=${args.endVisible}`;
return fetch(`https://js.devexpress.com/Demos/NetCore/api/TemperatureData${params}`)
.then((response) => response.json());
}
function getDateString(dateTime: Date | null): string {
return dateTime ? dateTime.toLocaleDateString('en-US') : '';
}
</script>
<style>
#chart {
height: 440px;
}
</style>
window.exports = window.exports || {};
window.config = {
transpiler: 'plugin-babel',
meta: {
'*.vue': {
loader: 'vue-loader',
},
'*.ts': {
loader: 'demo-ts-loader',
},
'*.svg': {
loader: 'svg-loader',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
},
paths: {
'project:': '../../../../',
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'vue': 'npm:vue@3.5.32/dist/vue.esm-browser.js',
'@vue/shared': 'npm:@vue/shared@3.4.27/dist/shared.cjs.prod.js',
'vue-loader': 'npm:dx-systemjs-vue-browser@1.1.2/index.js',
'demo-ts-loader': 'project:utils/demo-ts-loader.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'svg-loader': 'project:utils/svg-loader.js',
'whatwg-fetch': 'npm:whatwg-fetch@2.0.4/fetch.js',
'mitt': 'npm:mitt/dist/mitt.umd.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-vue': 'npm:devextreme-vue@link:../../packages/devextreme-vue/npm/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.9/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js',
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme-vue': {
main: 'index.js',
},
'devextreme-vue/common': {
main: 'index.js',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
},
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
import { createApp } from 'vue';
import App from './App.vue';
createApp(App).mount('#app');
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.2.8/css/dx.light.css" />
<script src="https://cdn.jsdelivr.net/npm/typescript@5.9.3/lib/typescript.js"></script>
<script type="module">
import * as vueCompilerSFC from "https://cdn.jsdelivr.net/npm/@vue/compiler-sfc@3.4.27/dist/compiler-sfc.esm-browser.js";
window.vueCompilerSFC = vueCompilerSFC;
</script>
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.ts");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"> </div>
</div>
</body>
</html>

<dx-chart
id="chart"
title="Temperature in Toronto (2025)"
[dataSource]="chartDataSource"
[zoomAndPan]="{ argumentAxis: 'pan' }"
>
<dxo-chart-scroll-bar [visible]="true"></dxo-chart-scroll-bar>
<dxo-chart-argument-axis
argumentType="datetime"
[(visualRange)]="currentVisualRange"
[wholeRange]="bounds"
>
</dxo-chart-argument-axis>
<dxi-chart-value-axis name="temperature" [allowDecimals]="false">
<dxo-chart-title text="Temperature, °C">
<dxo-chart-font color="#ff950c"></dxo-chart-font>
</dxo-chart-title>
<dxo-chart-label>
<dxo-chart-font color="#ff950c"></dxo-chart-font>
</dxo-chart-label>
</dxi-chart-value-axis>
<dxi-chart-series
color="#ff950c"
type="rangeArea"
argumentField="date"
rangeValue1Field="minTemp"
rangeValue2Field="maxTemp"
name="Temperature range"
>
</dxi-chart-series>
<dxo-chart-animation [enabled]="false"></dxo-chart-animation>
<dxo-chart-loading-indicator backgroundColor="none">
<dxo-chart-font [size]="14"></dxo-chart-font>
</dxo-chart-loading-indicator>
<dxo-chart-legend [visible]="false"></dxo-chart-legend>
</dx-chart>
import { bootstrapApplication } from '@angular/platform-browser';
import { Component, ViewChild, enableProdMode, provideZoneChangeDetection } from '@angular/core';
import { HttpClient, provideHttpClient, withFetch } from '@angular/common/http';
import { lastValueFrom } from 'rxjs';
import { DxChartComponent, DxChartModule } from 'devextreme-angular';
import { VisualRange } from 'devextreme-angular/common/charts';
import { DataSource } from 'devextreme-angular/common/data';
if (!/localhost/.test(document.location.host)) {
enableProdMode();
}
let modulePrefix = '';
// @ts-ignore
if (window && window.config?.packageConfigPaths) {
modulePrefix = '/app';
}
@Component({
selector: 'demo-app',
templateUrl: `app/app.component.html`,
styleUrls: [`app/app.component.css`],
imports: [
DxChartModule,
],
})
export class AppComponent {
@ViewChild(DxChartComponent, { static: false }) component: DxChartComponent;
private _visualRange: VisualRange = {
startValue: new Date(2025, 3, 1),
length: {
weeks: 2,
},
};
HALFDAY = 43200000;
packetsLock = 0;
chartDataSource = new DataSource({
store: [],
sort: 'date',
paginate: false,
});
bounds = {
startValue: new Date(2025, 0, 1),
endValue: new Date(2025, 11, 31),
};
constructor(private httpClient: HttpClient) {}
get currentVisualRange(): VisualRange {
return this._visualRange;
}
set currentVisualRange(range: VisualRange) {
this._visualRange.startValue = range.startValue;
this._visualRange.endValue = range.endValue;
this.onVisualRangeChanged();
}
onVisualRangeChanged() {
const items = this.component.instance.getDataSource().items();
const itemsFirstDate = items?.[0]?.date as number;
const itemsLastDate = items?.[items.length - 1]?.date as number;
const startDate = this._visualRange.startValue as number;
const endDate = this._visualRange.endValue as number;
if (!items.length
|| itemsFirstDate - startDate >= this.HALFDAY
|| endDate - itemsLastDate >= this.HALFDAY) {
this.uploadDataByVisualRange();
}
}
uploadDataByVisualRange() {
const dataSource = this.component.instance.getDataSource();
const ajaxArgs = {
startVisible: this.getDateString(this._visualRange.startValue as Date),
endVisible: this.getDateString(this._visualRange.endValue as Date),
};
if (!this.packetsLock) {
this.packetsLock += 1;
this.component.instance.showLoadingIndicator();
this.getDataFrame(ajaxArgs)
.then((dataFrame: Record<string, number | Date>[]) => {
this.packetsLock -= 1;
const componentStorage = dataSource.store();
dataFrame
.map((i) => ({
date: new Date(i.Date),
minTemp: i.MinTemp,
maxTemp: i.MaxTemp,
}))
.forEach((item) => componentStorage.insert(item));
dataSource.reload();
this.onVisualRangeChanged();
})
.catch(() => {
this.packetsLock -= 1;
dataSource.reload();
});
}
}
getDataFrame(args: Record<string, string>) {
const params = `startVisible=${args.startVisible}`
+ `&endVisible=${args.endVisible}`;
return lastValueFrom(
this.httpClient.get(`https://js.devexpress.com/Demos/NetCore/api/TemperatureData?${params}`),
);
}
getDateString(dateTime: Date) {
return dateTime ? dateTime.toLocaleDateString('en-US') : '';
}
}
bootstrapApplication(AppComponent, {
providers: [
provideZoneChangeDetection({ eventCoalescing: true, runCoalescing: true }),
provideHttpClient(withFetch()),
],
});
::ng-deep #chart {
height: 440px;
}
// In real applications, you should not transpile code in the browser.
// You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
const componentNames = [
'accordion',
'action-sheet',
'autocomplete',
'bar-gauge',
'box',
'bullet',
'button-group',
'button',
'calendar',
'card-view',
'chart',
'chat',
'check-box',
'circular-gauge',
'color-box',
'context-menu',
'data-grid',
'date-box',
'date-range-box',
'defer-rendering',
'diagram',
'draggable',
'drawer',
'drop-down-box',
'drop-down-button',
'file-manager',
'file-uploader',
'filter-builder',
'form',
'funnel',
'gallery',
'gantt',
'html-editor',
'linear-gauge',
'list',
'load-indicator',
'load-panel',
'lookup',
'map',
'menu',
'multi-view',
'nested',
'number-box',
'pagination',
'pie-chart',
'pivot-grid-field-chooser',
'pivot-grid',
'polar-chart',
'popover',
'popup',
'progress-bar',
'radio-group',
'range-selector',
'range-slider',
'recurrence-editor',
'resizable',
'responsive-box',
'sankey',
'scheduler',
'scroll-view',
'select-box',
'slider',
'sortable',
'sparkline',
'speech-to-text',
'speed-dial-action',
'splitter',
'stepper',
'switch',
'tab-panel',
'tabs',
'tag-box',
'text-area',
'text-box',
'tile-view',
'toast',
'toolbar',
'tooltip',
'tree-list',
'tree-map',
'tree-view',
'validation-group',
'validation-summary',
'validator',
'vector-map',
];
window.exports = window.exports || {};
window.config = {
transpiler: 'ts',
typescriptOptions: {
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
},
meta: {
'typescript': {
'exports': 'ts',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'@angular/platform-browser-dynamic': {
'esModule': true,
},
'@angular/platform-browser': {
'esModule': true,
},
'@angular/core': {
'esModule': true,
},
'@angular/common': {
'esModule': true,
},
'@angular/common/http': {
'esModule': true,
},
'@angular/animations': {
'esModule': true,
},
'@angular/forms': {
'esModule': true,
},
'openai': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'ts': 'npm:plugin-typescript@8.0.0/lib/plugin.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
/* @angular */
'@angular/compiler': 'bundles:@angular/compiler.umd.js',
'@angular/platform-browser-dynamic': 'bundles:@angular/platform-browser-dynamic.umd.js',
'@angular/core': 'bundles:@angular/core.umd.js',
'@angular/core/primitives/signals': 'bundles:@angular/core.primitives.signals.umd.js',
'@angular/core/primitives/di': 'bundles:@angular/core.primitives.di.umd.js',
'@angular/common': 'bundles:@angular/common.umd.js',
'@angular/common/http': 'bundles:@angular/common-http.umd.js',
'@angular/platform-browser': 'bundles:@angular/platform-browser.umd.js',
'@angular/platform-browser/animations': 'bundles:@angular/platform-browser.umd.js',
'@angular/forms': 'bundles:@angular/forms.umd.js',
/* devextreme */
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.9/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69',
/* devextreme-angular umd maps */
'devextreme-angular': 'bundles:devextreme-angular/devextreme-angular.umd.js',
'devextreme-angular/common/ai-integration': 'bundles:devextreme-angular/devextreme-angular-common-ai-integration.umd.js',
'devextreme-angular/core': 'bundles:devextreme-angular/devextreme-angular-core.umd.js',
'devextreme-angular/common/charts': 'bundles:devextreme-angular/devextreme-angular-common-charts.umd.js',
'devextreme-angular/common/core/animation': 'bundles:devextreme-angular/devextreme-angular-common-core-animation.umd.js',
'devextreme-angular/common/core/environment': 'bundles:devextreme-angular/devextreme-angular-common-core-environment.umd.js',
'devextreme-angular/common/core/events': 'bundles:devextreme-angular/devextreme-angular-common-core-events.umd.js',
'devextreme-angular/common/core/localization': 'bundles:devextreme-angular/devextreme-angular-common-core-localization.umd.js',
'devextreme-angular/common/core': 'bundles:devextreme-angular/devextreme-angular-common-core.umd.js',
'devextreme-angular/common/data/custom-store': 'bundles:devextreme-angular/devextreme-angular-common-data-custom-store.umd.js',
'devextreme-angular/common/data': 'bundles:devextreme-angular/devextreme-angular-common-data.umd.js',
'devextreme-angular/common/export/excel': 'bundles:devextreme-angular/devextreme-angular-common-export-excel.umd.js',
'devextreme-angular/common/export/pdf': 'bundles:devextreme-angular/devextreme-angular-common-export-pdf.umd.js',
'devextreme-angular/common/export': 'bundles:devextreme-angular/devextreme-angular-common-export.umd.js',
'devextreme-angular/common/grids': 'bundles:devextreme-angular/devextreme-angular-common-grids.umd.js',
'devextreme-angular/common': 'bundles:devextreme-angular/devextreme-angular-common.umd.js',
'devextreme-angular/http': 'bundles:devextreme-angular/devextreme-angular-http.umd.js',
'devextreme-angular/core/tokens': 'bundles:devextreme-angular/devextreme-angular-core-tokens.umd.js',
...componentNames.reduce((acc, name) => {
acc[`devextreme-angular/ui/${name}`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}.umd.js`;
acc[`devextreme-angular/ui/${name}/nested`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}-nested.umd.js`;
return acc;
}, {}),
'tslib': 'npm:tslib/tslib.js',
'rxjs': 'npm:rxjs@7.5.3/dist/bundles/rxjs.umd.js',
'rxjs/operators': 'npm:rxjs@7.5.3/dist/cjs/operators/index.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
'zone.js': 'npm:zone.js@0.15.1/bundles/zone.umd.js',
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
'rxjs': {
defaultExtension: 'js',
},
'rxjs/operators': {
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:rxjs@7.5.3/package.json',
'npm:rxjs@7.5.3/operators/package.json',
'npm:devexpress-diagram@2.2.29/package.json',
'npm:devexpress-gantt@4.1.69/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line no-console
// System.import('@angular/compiler').catch(console.error.bind(console));
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"@angular/core": {
"version": "21.2.11"
},
"core-js": {
"version": "2.6.12"
},
"typescript": {
"version": "5.9.3"
},
"zone.js": {
"version": "0.15.1"
}
};
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.2.8/css/dx.light.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/zone.js@0.15.1/bundles/zone.umd.js"></script>
<script src="https://cdn.jsdelivr.net/npm/reflect-metadata@0.1.13/Reflect.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import("app").catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>

import React, { useState } from 'react';
import { DataSource } from 'devextreme-react/common/data';
import {
Chart,
type ChartTypes,
ZoomAndPan,
ScrollBar,
ArgumentAxis,
ValueAxis,
Title,
Label,
Font,
Legend,
Series,
Animation,
LoadingIndicator,
} from 'devextreme-react/chart';
const HALFDAY = 43200000;
let packetsLock = 0;
const chartDataSource = new DataSource({
store: [],
sort: 'date',
paginate: false,
});
const wholeRange = {
startValue: new Date(2017, 0, 1),
endValue: new Date(2017, 11, 31),
};
function App() {
const [visualRange, setVisualRange] = useState({
startValue: new Date(2017, 3, 1),
endValue: new Date(2017, 3, 15),
});
const handleChange = (e: ChartTypes.OptionChangedEvent) => {
if (e.fullName === 'argumentAxis.visualRange') {
const stateStart = visualRange.startValue;
const currentStart = e.value.startValue;
if (stateStart.valueOf() !== currentStart.valueOf()) {
setVisualRange(e.value);
}
onVisualRangeChanged(e.value, e.component);
}
};
return (
<Chart
id="chart"
title="Temperature in Toronto (2017)"
dataSource={chartDataSource}
onOptionChanged={handleChange}
>
<ZoomAndPan argumentAxis="pan" />
<ScrollBar visible={true} />
<ArgumentAxis
argumentType="datetime"
visualRangeUpdateMode="keep"
visualRange={visualRange}
wholeRange={wholeRange}
/>
<ValueAxis name="temperature" allowDecimals={false}>
<Title text='Temperature, °C'>
<Font color="#ff950c" />
</Title>
<Label>
<Font color="#ff950c" />
</Label>
</ValueAxis>
<Series
color="#ff950c"
type="rangearea"
argumentField="date"
rangeValue1Field="minTemp"
rangeValue2Field="maxTemp"
name="Temperature range"
/>
<Animation enabled={false} />
<LoadingIndicator backgroundColor="none">
<Font size={14} />
</LoadingIndicator>
<Legend visible={false} />
</Chart>
);
}
const uploadDataByVisualRange = (visualRange, component) => {
const dataSource = component.getDataSource();
const ajaxArgs = {
startVisible: getDateString(visualRange.startValue),
endVisible: getDateString(visualRange.endValue),
};
if (!packetsLock) {
packetsLock += 1;
component.showLoadingIndicator();
getDataFrame(ajaxArgs)
.then((dataFrame) => {
packetsLock -= 1;
const componentStorage = dataSource.store();
dataFrame
.map((i) => ({
date: new Date(i.Date),
minTemp: i.MinTemp,
maxTemp: i.MaxTemp,
}))
.forEach((item) => componentStorage.insert(item));
dataSource.reload();
onVisualRangeChanged(visualRange, component);
})
.catch(() => {
packetsLock -= 1;
dataSource.reload();
});
}
};
const onVisualRangeChanged = (visualRange, component) => {
const items = component.getDataSource().items();
if (
!items.length
|| items[0].date - visualRange.startValue.getTime() >= HALFDAY
|| visualRange.endValue.getTime() - items[items.length - 1].date >= HALFDAY
) {
uploadDataByVisualRange(visualRange, component);
}
};
function getDataFrame(args) {
let params = '?';
params += `startVisible=${args.startVisible}
&endVisible=${args.endVisible}`;
return fetch(
`https://js.devexpress.com/Demos/NetCore/api/TemperatureData${params}`,
).then((response) => response.json());
}
function getDateString(dateTime) {
return dateTime ? dateTime.toLocaleDateString('en-US') : '';
}
export default App;
import React, { useState } from 'react';
import { DataSource } from 'devextreme-react/common/data';
import {
Chart,
ZoomAndPan,
ScrollBar,
ArgumentAxis,
ValueAxis,
Title,
Label,
Font,
Legend,
Series,
Animation,
LoadingIndicator,
} from 'devextreme-react/chart';
const HALFDAY = 43200000;
let packetsLock = 0;
const chartDataSource = new DataSource({
store: [],
sort: 'date',
paginate: false,
});
const wholeRange = {
startValue: new Date(2017, 0, 1),
endValue: new Date(2017, 11, 31),
};
function App() {
const [visualRange, setVisualRange] = useState({
startValue: new Date(2017, 3, 1),
endValue: new Date(2017, 3, 15),
});
const handleChange = (e) => {
if (e.fullName === 'argumentAxis.visualRange') {
const stateStart = visualRange.startValue;
const currentStart = e.value.startValue;
if (stateStart.valueOf() !== currentStart.valueOf()) {
setVisualRange(e.value);
}
onVisualRangeChanged(e.value, e.component);
}
};
return (
<Chart
id="chart"
title="Temperature in Toronto (2017)"
dataSource={chartDataSource}
onOptionChanged={handleChange}
>
<ZoomAndPan argumentAxis="pan" />
<ScrollBar visible={true} />
<ArgumentAxis
argumentType="datetime"
visualRangeUpdateMode="keep"
visualRange={visualRange}
wholeRange={wholeRange}
/>
<ValueAxis
name="temperature"
allowDecimals={false}
>
<Title text="Temperature, °C">
<Font color="#ff950c" />
</Title>
<Label>
<Font color="#ff950c" />
</Label>
</ValueAxis>
<Series
color="#ff950c"
type="rangearea"
argumentField="date"
rangeValue1Field="minTemp"
rangeValue2Field="maxTemp"
name="Temperature range"
/>
<Animation enabled={false} />
<LoadingIndicator backgroundColor="none">
<Font size={14} />
</LoadingIndicator>
<Legend visible={false} />
</Chart>
);
}
const uploadDataByVisualRange = (visualRange, component) => {
const dataSource = component.getDataSource();
const ajaxArgs = {
startVisible: getDateString(visualRange.startValue),
endVisible: getDateString(visualRange.endValue),
};
if (!packetsLock) {
packetsLock += 1;
component.showLoadingIndicator();
getDataFrame(ajaxArgs)
.then((dataFrame) => {
packetsLock -= 1;
const componentStorage = dataSource.store();
dataFrame
.map((i) => ({
date: new Date(i.Date),
minTemp: i.MinTemp,
maxTemp: i.MaxTemp,
}))
.forEach((item) => componentStorage.insert(item));
dataSource.reload();
onVisualRangeChanged(visualRange, component);
})
.catch(() => {
packetsLock -= 1;
dataSource.reload();
});
}
};
const onVisualRangeChanged = (visualRange, component) => {
const items = component.getDataSource().items();
if (
!items.length
|| items[0].date - visualRange.startValue.getTime() >= HALFDAY
|| visualRange.endValue.getTime() - items[items.length - 1].date >= HALFDAY
) {
uploadDataByVisualRange(visualRange, component);
}
};
function getDataFrame(args) {
let params = '?';
params += `startVisible=${args.startVisible}
&endVisible=${args.endVisible}`;
return fetch(`https://js.devexpress.com/Demos/NetCore/api/TemperatureData${params}`).then(
(response) => response.json(),
);
}
function getDateString(dateTime) {
return dateTime ? dateTime.toLocaleDateString('en-US') : '';
}
export default App;
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.tsx';
ReactDOM.render(
<App />,
document.getElementById('app'),
);
window.exports = window.exports || {};
window.config = {
transpiler: 'ts',
typescriptOptions: {
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
jsx: 'react',
},
meta: {
'react': {
'esModule': true,
},
'typescript': {
'exports': 'ts',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
},
defaultExtension: 'js',
map: {
'ts': 'npm:plugin-typescript@8.0.0/lib/plugin.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'react': 'npm:react@17.0.2/umd/react.development.js',
'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js',
'prop-types': 'npm:prop-types/prop-types.js',
'whatwg-fetch': 'npm:whatwg-fetch@2.0.4/fetch.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-react': 'npm:devextreme-react@link:../../packages/devextreme-react/npm/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.6/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.24/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.64/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.8.0/dist/signals-core.min.js',
'devextreme-cldr-data': 'npm:devextreme-cldr-data@1.0.3',
// SystemJS plugins
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme': {
defaultExtension: 'js',
},
'devextreme-react': {
main: 'index.js',
},
'devextreme-react/common': {
main: 'index.js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/localization/messages': {
format: 'json',
defaultExtension: 'json',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
react: true,
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.js';
ReactDOM.render(<App />, document.getElementById('app'));
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.1.7/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.tsx");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>
#chart {
height: 440px;
}